module altcnfig (
clk,
rst,

syscheck0,

syscnfig1,
syscnfig2,
syscnfig3,

syscheck4,

syscnfig5,
syscnfig6,
syscnfig7,

syscheck8,

syscnfig9,
syscnfigA,
syscnfigB,

syscheckC,

syscnfigD,
syscnfigE,
syscnfigF,

syscheck10,

syscnfig11,
syscnfig12,
syscnfig13,

syscheck14,

syscnfig15,
syscnfig16,
syscnfig17,

syscheck18,

syscnfig19,
syscnfig1A,
syscnfig1B,

syscheck1C,

syscnfig1D,
syscnfig1E,
syscnfig1F


);

input clk;
input rst;

input [7:0] syscheck0;
output [7:0] syscnfig1;
output [7:0] syscnfig2;
output [7:0] syscnfig3;
input [7:0] syscheck4;
output [7:0] syscnfig5;
output [7:0] syscnfig6;
output [7:0] syscnfig7;
input [7:0] syscheck8;
output [7:0] syscnfig9;
output [7:0] syscnfigA;
output [7:0] syscnfigB;
input [7:0] syscheckC;
output [7:0] syscnfigD;
output [7:0] syscnfigE;
output [7:0] syscnfigF;
input [7:0] syscheck10;
output [7:0] syscnfig11;
output [7:0] syscnfig12;
output [7:0] syscnfig13;
input [7:0] syscheck14;
output [7:0] syscnfig15;
output [7:0] syscnfig16;
output [7:0] syscnfig17;
input [7:0] syscheck18;
output [7:0] syscnfig19;
output [7:0] syscnfig1A;
output [7:0] syscnfig1B;
input [7:0] syscheck1C;
output [7:0] syscnfig1D;
output [7:0] syscnfig1E;
output [7:0] syscnfig1F;

reg [7:0] syscnfig1;
reg [7:0] syscnfig2;
reg [7:0] syscnfig3;

reg [7:0] syscnfig5;
reg [7:0] syscnfig6;
reg [7:0] syscnfig7;

reg [7:0] syscnfig9;
reg [7:0] syscnfigA;
reg [7:0] syscnfigB;

reg [7:0] syscnfigD;
reg [7:0] syscnfigE;
reg [7:0] syscnfigF;

reg [7:0] syscnfig11;
reg [7:0] syscnfig12;
reg [7:0] syscnfig13;

reg [7:0] syscnfig15;
reg [7:0] syscnfig16;
reg [7:0] syscnfig17;

reg [7:0] syscnfig19;
reg [7:0] syscnfig1A;
reg [7:0] syscnfig1B;

reg [7:0] syscnfig1D;
reg [7:0] syscnfig1E;
reg [7:0] syscnfig1F;

wire [7:0] crmq;

reg [4:0] crma;
reg [1:0] crma_reg;
reg       crmw;

always @(posedge clk or negedge rst)
  if (~rst)
  begin
    crma     <= #1 5'h0;
    crma_reg <= #1 2'h0;
  end  
  else
  begin
    crma     <= #1 crma + 1;
    crma_reg <= #1 crma_reg + 1;
  end

always @(posedge clk or negedge rst)
  if (~rst)
    crmw     <= #1 1'b0;
  else if (crma_reg == 2'b11)
    crmw     <= #1 1'b1;
  else
    crmw     <= #1 1'b0;    
      

reg [7:0] crmd;  
altcnfigram1 altcnfigram1(
.address(crma),
.clock(clk),
.data(crmd),
.wren(crmw),
.q(crmq));


always @(posedge clk or negedge rst)
  if (~rst)
  begin
    syscnfig1E <= #1 8'h00;
    syscnfig1F <= #1 8'h00;
              
    syscnfig1  <= #1 8'h00;
    syscnfig2  <= #1 8'h00;
    syscnfig3  <= #1 8'h00;
              
    syscnfig5  <= #1 8'h00;
    syscnfig6  <= #1 8'h00;
    syscnfig7  <= #1 8'h00; 
              
    syscnfig9  <= #1 8'h00;
    syscnfigA  <= #1 8'h00;
    syscnfigB  <= #1 8'h00;
                
    syscnfigD  <= #1 8'h00;
    syscnfigE  <= #1 8'h00;
    syscnfigF  <= #1 8'h00;
              
    syscnfig11 <= #1 8'h00;
    syscnfig12 <= #1 8'h00;
    syscnfig13 <= #1 8'h00;
                
    syscnfig15 <= #1 8'h00;
    syscnfig16 <= #1 8'h00;
    syscnfig17 <= #1 8'h00;
              
    syscnfig19 <= #1 8'h00;
    syscnfig1A <= #1 8'h00; 
    syscnfig1B <= #1 8'h00;
              
    syscnfig1D <= #1 8'h01;
  end
  else  
   casex({crma})
   5'h00 : syscnfig1E <= #1 crmq;
   5'h01 : syscnfig1F <= #1 crmq;
   
   5'h03 : syscnfig1 <= #1 crmq;
   5'h04 : syscnfig2 <= #1 crmq;
   5'h05 : syscnfig3 <= #1 crmq;
  
   5'h07 : syscnfig5 <= #1 crmq;
   5'h08 : syscnfig6 <= #1 crmq;
   5'h09 : syscnfig7 <= #1 crmq; 
  
   5'h0b : syscnfig9 <= #1 crmq;
   5'h0c : syscnfigA <= #1 crmq;
   5'h0d : syscnfigB <= #1 crmq;
     
   5'h0f : syscnfigD <= #1 crmq;
   5'h10 : syscnfigE <= #1 crmq;
   5'h11 : syscnfigF <= #1 crmq;
   
   5'h13 : syscnfig11 <= #1 crmq;
   5'h14 : syscnfig12 <= #1 crmq;
   5'h15 : syscnfig13 <= #1 crmq;
     
   5'h17 : syscnfig15 <= #1 crmq;
   5'h18 : syscnfig16 <= #1 crmq;
   5'h19 : syscnfig17 <= #1 crmq;
   
   5'h1b : syscnfig19 <= #1 crmq;
   5'h1c : syscnfig1A <= #1 crmq; 
   5'h1d : syscnfig1B <= #1 crmq;
   
   5'h1f : syscnfig1D <= #1 crmq;
   default  : begin
              syscnfig1E <= #1 syscnfig1E;
              syscnfig1F <= #1 syscnfig1F;
              
              syscnfig1  <= #1 syscnfig1;
              syscnfig2  <= #1 syscnfig2;
              syscnfig3  <= #1 syscnfig3;
              
              syscnfig5  <= #1 syscnfig5;
              syscnfig6  <= #1 syscnfig6;
              syscnfig7  <= #1 syscnfig7; 
              
              syscnfig9  <= #1 syscnfig9;
              syscnfigA  <= #1 syscnfigA;
              syscnfigB  <= #1 syscnfigB;
                
              syscnfigD  <= #1 syscnfigD;
              syscnfigE  <= #1 syscnfigE;
              syscnfigF  <= #1 syscnfigF;
              
              syscnfig11 <= #1 syscnfig11;
              syscnfig12 <= #1 syscnfig12;
              syscnfig13 <= #1 syscnfig13;
                
              syscnfig15 <= #1 syscnfig15;
              syscnfig16 <= #1 syscnfig16;
              syscnfig17 <= #1 syscnfig17;
              
              syscnfig19 <= #1 syscnfig19;
              syscnfig1A <= #1 syscnfig1A; 
              syscnfig1B <= #1 syscnfig1B;
              
              syscnfig1D <= #1 syscnfig1D;
              end     
   endcase

   
always @(posedge clk or negedge rst)
  if(~rst)
    crmd <= #1 8'b0;
  else  
   casex({crma})
   5'h02    : crmd <= #1 syscheck4;
   5'h06    : crmd <= #1 syscheck8;
   5'h0a    : crmd <= #1 syscheckC;
   5'h0e    : crmd <= #1 syscheck10;  
   5'h12    : crmd <= #1 syscheck14;
   5'h16    : crmd <= #1 syscheck18;  
   5'h1a    : crmd <= #1 syscheck1C;
   5'h1e    : crmd <= #1 syscheck0;
   default  : crmd <= #1 crmd;
   endcase
   

endmodule
